'
' listComPorts -- List all COM, even USB-to-serial-based onesports,
'                 along with other info about them
'
' Execute on the command line with:
'   cscript.exe //nologo listComPorts.vbs
'
' http://github.com/todbot/usbSearch
'
' 2012, Tod E. Kurt, https://todbot.com/blog/
' 2017  N. Teering: Fixed devicename with Null value
'
' core idea stolen from
' http://collectns.blogspot.com/2011/11/vbscript-for-detecting-usb-serial-com.html
' And this is fun, if not particularly useful:
' http://henryranch.net/software/jwmi-query-windows-wmi-from-java/



Set portList = GetComPorts()

Set oShell = CreateObject("WScript.Shell")
portnames = portList.Keys
for each pname in portnames
    Set portinfo = portList.item(pname)
    if (InStr(portinfo.Name, "CP210")>0 Or InStr(portinfo.Name, "CH340")>0 Or InStr(portinfo.Name, "CH9102")>0) Then
	    'wscript.echo pname & " - " & portinfo.name'
	    wscript.echo "ILDAC-32 module found on COM port: " & pname & " In the next dialog box, please select the *.bin file you wish to upload to the module."
	    filePath =Chr(34)& BrowseForFile()&Chr(34)
		if filePath = "" Then
		  wscript.echo "Operation canceled, quitting firmware update"
		  WScript.Quit
		Else
		    wscript.echo "BIN file selected  " & filePath & ". Please do not close the DOS window that will popup next. When the update is complete, press any key to close the update window."
	  	    oShell.run "%COMSPEC% /c esptool.exe --chip esp32 --port "& pname & " --baud 921600   --before default_reset --after hard_reset write_flash -z --flash_mode dio --flash_freq 40m --flash_size detect 0x1000 bootloader_dio_40m.bin 0x8000 partitions.bin 0xe000 boot_app0.bin 0x10000 "& filePath & " & echo. & echo. & echo. & echo 'Firmware Update Complete. Uploading Test Patterns...' & %COMSPEC% /c esptool.exe --baud 921600 --port "& pname & " write_flash 0x3B0000 spiffs.bin -u & echo Done. & pause "
		End if
	end if
Next
if filePath="" Then wscript.echo "No ESP32 com port found"

'
' For all the keys in an entity, see
'http://msdn.microsoft.com/en-us/library/windows/desktop/aa394353(v=vs.85).aspx
'
Function GetComPorts()
    set portList = CreateObject("Scripting.Dictionary")

    strComputer = "."
    set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
    set colItems = objWMIService.ExecQuery ("Select * from Win32_PnPEntity")
    for each objItem in colItems
        If Not IsNull(objItem.Name) Then
        	set objRgx = CreateObject("vbScript.RegExp")
        	objRgx.Pattern = "COM[0-9]+"
	        Set objRegMatches = objRgx.Execute(objItem.Name)
	        if objRegMatches.Count = 1 Then  portList.Add objRegMatches.Item(0).Value, objItem
	    End if
    Next
    set GetComPorts = portList
End Function



'--------------------------------------------------------------------------------------
Function BrowseForFile()
'@description: Browse for file dialog.
'@author: Jeremy England (SimplyCoded)
  BrowseForFile = CreateObject("WScript.Shell").Exec( _
    "mshta.exe ""about:<input type=file id=f>" & _
    "<script>resizeTo(0,0);f.click();new ActiveXObject('Scripting.FileSystemObject')" & _
    ".GetStandardStream(1).WriteLine(f.value);close();</script>""" _
  ).StdOut.ReadLine()
End Function